package rabbit.awt;

// $Id: Meter.java,v 1.1.1.1 1999/12/18 18:49:32 robo Exp $

import java.awt.*;

/** This is a graphical meter for things.
 *  The metervalue should be between 0 and 1.
 */
public class Meter extends Component {
    
    /** @serial */
    private double meter = 0;        
    
    /** The standard constructor.
     */
    public Meter () {
    }

    /** Get the value of the meter
     * @return the value of the meter.
     */
    public double getMeter () {
	return meter;
    }

    /** Set the meter to a new value
     *  If the value supplied is not in the range [0,1] it is adjusted 
     *  to the closest endpoint.
     * @param i the new value of the meter.
     */
    public void setMeter (double i) {
	meter = i;
	if (i < 0)
	    meter = 0;
	if (i > 1)
	    meter = 1;
	update (getGraphics ());
    }
    
    /** Paint this meter on a Graphics
     * @param g the Graphics to paint on.
     */
    public void paint (Graphics g) {
	Dimension wh = getSize ();
	int width = (int)(wh.width * meter);
	g.setColor (getForeground ());
	g.fillRect (0, 0, width, wh.height);	
    }
}
