package rabbit.filter;

// $Id: BackgroundFilter.java,v 1.5 2002/05/26 18:58:38 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** This class removes background images from html pages.
 */
public class BackgroundFilter extends HTMLFilter {
    private boolean done = false;

    /** Create a new BackgroundFilter for the given request, response pair.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public BackgroundFilter (HTTPHeader request, HTTPHeader response) {	
	super (request, response);
    }

    /** Remove background images from the given block.
     * @param block the part of the html page we are filtering.
     */
    public void filterHTML (HTMLBlock block) {
	Vector tokens = block.getTokens ();
	int tsize = tokens.size ();
	for (int i = 0; i < tsize; i++) {
	    Token t = (Token)tokens.elementAt (i);
	    switch (t.getType ()) {
	    case Token.TAG:
		Tag tag = t.getTag ();
		TagType type = tag.getTagType ();
		if (type == TagType.BODY || 
		    type == TagType.TABLE || 
		    type == TagType.TR || 
		    type == TagType.TD) {
		    tag.removeAttribute ("background");
		} 
	    default:
	    }
	}	
    }
}
