package rabbit.filter;

// $Id: BlinkFilter.java,v 1.5 2002/05/26 18:58:38 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** A filter that removes the blink and /blink tags.
 */
public class BlinkFilter extends HTMLFilter {

    /** Create a new BlinkFilter for the given request, response pair.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public BlinkFilter (HTTPHeader request, HTTPHeader response) {	
	super (request, response);
    }

    /** Remove blink tags.
     * @param block the part of the html page we are filtering.
     */
    public void filterHTML (HTMLBlock block) {
	Vector tokens = block.getTokens ();
	int tsize = tokens.size ();
	for (int i = 0; i < tsize; i++) {
	    Token t = (Token)tokens.elementAt (i);
	    switch (t.getType ()) {
	    case Token.TAG:
		Tag tag = t.getTag ();
		TagType tt = tag.getTagType ();
		if (tt == TagType.BLINK || 
		    tt == TagType.SBLINK) {
		    block.removeToken (i);		    
		}
	    default:
	    }
	}
    } 
}
