package rabbit.filter;

// $Id: BlockFilter.java,v 1.1.1.1 1999/12/18 18:49:32 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** This is a class that blocks access to certain part of the www.
 */
public class BlockFilter 
{
    private static Properties config = new Properties ();
   
    /** To block creation of this class.
     */
    private BlockFilter () {
    }
    
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public static HTTPHeader doHTTPInFiltering (Socket socket, HTTPHeader header, Connection con) {
	StringTokenizer st = new StringTokenizer (config.getProperty ("blockURLmatching", ""), ",");
	while (st.hasMoreTokens ()) {
	    if (header.getRequestURI ().indexOf (st.nextToken ()) > -1)
		return con.get403 ();
	}	
	return null;
    }
    
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public static HTTPHeader doHTTPOutFiltering (Socket socket, HTTPHeader header, Connection con) {
	return null;
    }

    /** Setup this class with the given properties.
     * @param properties the new configuration of this class.
     */
    public static void setup (Properties properties) {
	config = properties;
    }
}
