package rabbit.filter;

// $Id: HTMLFilter.java,v 1.1.1.1 1999/12/18 18:49:32 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** This class describes the functions neccessary to filter a block of
 *  html. 
 */
public abstract class HTMLFilter {
    /** The actual request made. */
    protected HTTPHeader request;
    /** The actual response. */
    protected HTTPHeader response;

    /** Create a new HTMLFilter for the given request, response pair.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public HTMLFilter (HTTPHeader request, HTTPHeader response) {	
	this.request = request;
	this.response = response;
    }
    
    /** Filter a block of html.
     * @param block the part of the html page to filter.
     */
    public abstract void filterHTML (HTMLBlock block);
}
