package rabbit.filter;

// $Id: HTTPSnoop.java,v 1.3 2000/02/20 12:12:41 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** This is a class that prints the HTTP headers on the standard out stream.
 */
public class HTTPSnoop 
{
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public static HTTPHeader doHTTPInFiltering (Socket socket, HTTPHeader header, Connection con) {
	System.out.println (header.toString ());
	return null;
    }
    
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public static HTTPHeader doHTTPOutFiltering (Socket socket, HTTPHeader header, Connection con) {
	System.out.println (con.getRequestLine () + "\n" + header.toString ());
	return null;
    }

    /** Setup this class with the given properties.
     * @param properties the new configuration of this class.
     */
    public static void setup (Properties properties) {
	
    }
}

