package rabbit.filter;

// $Id: LowresImageFilter.java,v 1.6 2002/05/26 18:58:38 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** This filter removes the &quot;<tt>lowsrc=some_image.gif</tt>&quot; attributes
 *  from the &lt;img> tags.
 */
public class LowresImageFilter extends HTMLFilter {

    /** Create a new LowresImageFilter for the given request, response pair.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public LowresImageFilter (HTTPHeader request, HTTPHeader response) {	
	super (request, response);
    }

    /** remove the lowres tags.
     * @param block the part of the html page we are filtering.
     */
    public void filterHTML (HTMLBlock block) {
	Vector tokens = block.getTokens ();
	int tsize = tokens.size ();
	for (int i = 0; i < tsize; i++) {
	    Token t = (Token)tokens.elementAt (i);
	    switch (t.getType ()) {
	    case Token.TAG:
		Tag tag = t.getTag ();
		if (tag.getTagType () == TagType.IMG) {
		    tag.removeAttribute ("lowsrc");
		}
	    default:
	    }
	}	
    }
}
