package rabbit.fsa;

// $Id$

import java.util.*;

public class FSA {

    private boolean isFinal = false;
    private Vector transitions = new Vector (2);
    
    public class Transition {
	Character ch;   // use null for epsilon state.
	FSA state;
	
	public Transition (Character ch, FSA state) {
	    this.ch = ch;
	    this.state = state;
	}
    }
    
    public boolean match (String s) {
	//System.err.println ("match: " + s);
	if (isFinal)
	    return true;
	if (s.length () < 1)
	    return false;
	char c = s.charAt (0);
	String rest = s.substring (1);
	Vector v = getTransitions (new Character (c));
	//System.err.println ("got " + v.size () + " transitions");
	for (int i = 0; i < v.size (); i++) {
	    Transition t = (Transition)v.elementAt (i);
	    FSA f = t.state;
	    if (f.match (rest))
		return true;
	}
	return false;
    }

    public Vector getTransitions (Character c) {
	Vector ret = new Vector (2);
	for (int i = 0; i < transitions.size (); i++) {
	    Transition t = (Transition)transitions.elementAt (i);
	    if (t.ch == null || 
		t.ch.equals (c))
		ret.addElement (t);
	}
	return ret;
    }
    
    public FSA (String s) {
	this (s, null);
    }

    public FSA (String s, FSA startstate) {
	if (s == null || s.length () == 0) {
	    isFinal = true;
	}
	else {
	    char c = s.charAt (0);
	    String rest = s.substring (1);
	    if (startstate == null)
		startstate = this;
	    FSA fr = new FSA (rest, startstate);
	    transitions.addElement (new Transition (new Character (c), fr));
	    transitions.addElement (new Transition (null, startstate));
	}
    }

    public FSA (FSA first, FSA second) {
	
    }

    public static void main (String[] args) {
	if (args.length < 1) {
	    System.exit (0);
	}
	
	String re = args[0];
	FSA fsa = new FSA (re);
	
	for (int i = 1; i < args.length; i++) {
	    System.out.println ("fsa matches " + args[i] + ":" + fsa.match (args[i]));
	}
    }    
}
