package rabbit.fsa;

// $Id$

import java.util.*;


public class RE {

    private RE end;  // the finalstate...    
    private boolean isFinal = false;
    private Vector transitions = new Vector (2);

    public class Transition {
	Character ch;   // use null for epsilon state.
	RE state;
	
	public Transition (Character ch, RE state) {
	    this.ch = ch;
	    this.state = state;
	}
	
	public String toString () {
	    return "transition: " + ch;
	}
    }


    public RE () {
	isFinal = true;
    }

    public RE (char ch) {
	end = new RE ();
	Transition t = new Transition (new Character (ch), end);
	transitions.addElement (t);
    }

    public boolean match (String s) {
	if (isFinal)
	    return true;
	Character ch = null;
	String rest = null;
	if (s != null && s.length () > 0) {
	    ch = new Character (s.charAt (0));
	    rest = s.substring (1);
	}
	Vector v = getTransitions (ch);
	for (int i = 0; i < v.size (); i++) {
	    Transition t = (Transition)v.elementAt (i);
	    RE f = t.state;
	    if (t.ch != null) {
		if (f.match (rest))
		    return true;
	    } else {
		if (f.match (s))
		    return true;
	    }
	}
	return false;
    }

    public Vector getTransitions (Character c) {
	Vector ret = new Vector (2);
	for (int i = 0; i < transitions.size (); i++) {
	    Transition t = (Transition)transitions.elementAt (i);
	    if (t.ch == null || 
		t.ch.equals (c))
		ret.addElement (t);
	}
	return ret;
    }
    
    public RE append (RE re) {
	end.isFinal = false;
	end.transitions = re.transitions;
	return this;
    }    
    
    public RE or (RE re) {
	RE start = new RE ();
	RE realend = new RE ();
	start.end = realend;

	start.isFinal = false;
	end.isFinal = false;
	re.end.isFinal = false;
	
	start.transitions.addElement (new Transition (null, this));
	start.transitions.addElement (new Transition (null, re));
	end.transitions.addElement (new Transition (null, realend));	
	re.end.transitions.addElement (new Transition (null, realend));
	return start;
    }

    public RE star () {
	RE start = new RE ();
	RE realend = new RE ();
	start.end = realend;
	start.isFinal = false;
	end.isFinal = false;
	
	start.transitions.addElement (new Transition (null, realend));	
	start.transitions.addElement (new Transition (null, this));
	end.transitions.addElement (new Transition (null, this));
	end.transitions.addElement (new Transition (null, realend));	
	return start;
    }
    
    public static void main (String[] args) {
	RE rea = new RE ('a');
	RE rea2 = new RE ('a');
	RE reb = new RE ('b');
	RE rec = new RE ('c');

	RE rb = reb.star ();
	RE rab = rea.append (rb);
	RE re = rab.append (rea2);
	
	for (int i = 0; i < args.length; i++) {
	    System.err.println ("re.match(\"" + args[i] + "\"): " + re.match (args[i]));
	}
    }    

}




