package rabbit.linkchecker;

// $Id: Logger.java,v 1.3 2001/07/05 21:14:30 robo Exp $

import java.net.*;

import rabbit.http.*;
import rabbit.util.*;

/** An interface for logging the page handled.
 *  For each URL that is visited by the linkchecker a call to log is made.
 */
public interface Logger {
    /** This method is called upon on errors and other strange stuff.
     */
    public void log (URL url, String msg);       
    
    /** This method is called when a request is fulfilled ok.
     */
    public void log (URL url, HTTPHeader header);    

    /** This method is called when this Logger is started.
     * @param cfg the global Config.
     */
    public void startLogging (Config cfg);

    /** This method is called when this Logger is stopped.
     */
    public void endLogging ();    
}
