package rabbit.meta;

// $Id: AccessGetter.java,v 1.2 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.filter.*;
import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** A metapage that allows setting of the valid ip addreses.
 */
public class AccessGetter implements MetaHandler {
    private static final String mark = "access=";

    /** default constructor */
    public AccessGetter () {
    }
    
    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	HTTPHeader response = con.getHeader ();
	StringBuffer res = new StringBuffer ();
	
	String content = header.getContent ();
	if (content != null) {
	    int i = content.indexOf (mark);
	    String userstring = null;
	    if (i > -1) {
		int j = content.indexOf ('&', i);
		if (j == -1)
		    j = content.length ();
		if (j > -1) {
		    userstring = content.substring (i + mark.length (),j);
		    userstring = Coder.URLdecode (userstring);
		    try {
			AccessFilter.loadAccess (new StringReader (userstring));
			AccessFilter.saveAccess (new StringReader (userstring));
		    } catch (IOException e) {
			// Ignore..
		    }
		}
	    }
	}

	res.append (HTMLPage.getPageHeader ("IP Access Configuration"));
	
	res.append ("<form method=post action=AccessGetter><TEXTAREA name=access ROWS=10 COLS=55>");
	Vector iplist = AccessFilter.getIPList ();
	for (int i = 0; i < iplist.size (); i++) {
	    IPAccess ipa = (IPAccess)iplist.elementAt (i);
	    res.append (ipa.toString ());
	    res.append ('\n');
	}
	res.append ("</textarea><br><input type=\"submit\" value=\"Save\"></form>");
	res.append ("</body></html>");

	try {      
	    output.writeHTTPHeader (response);
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write " + getClass().getName());
	}	
    }
}
