package rabbit.meta;

// $Id: CacheStatus.java,v 1.5 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.cache.*;
import rabbit.http.*;
import rabbit.html.*;
import rabbit.io.*;
import rabbit.proxy.*;

/** Get that status of the cache.
 */
public class CacheStatus implements MetaHandler {
    /** default constructor */
    public CacheStatus () {
    }

    /** handler of a MetaPage.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param url the requested url.
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param responder the Responder that is serving this metapage.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {      
	    long cursizemb = Proxy.getCache ().getCurrentSize ();
	    cursizemb /= (1024 * 1024);
	    long maxsizemb = Proxy.getCache ().getMaxSize ();
	    maxsizemb /= (1024 * 1024);
	    long cachetimeh =  Proxy.getCache ().getCacheTime ();
	    cachetimeh /= (1000 * 60 * 60);
	    output.writeHTTPHeader (con.getHeader ());
	    StringBuffer res = new StringBuffer (HTMLPage.getPageHeader ("CacheStatus") + 
						 "Cachedir   : " + Proxy.getCache ().getCacheDir () + ".<br>\n" +
						 "#Cached files: " + Proxy.getCache ().getNumberOfEntries () + ".<br>\n" + 
						 "current Size: " + cursizemb + " MB.<br>\n" +
						 "Max Size: " + maxsizemb + " MB.<br>\n" +
						 "Cachetime : " + cachetimeh + " hours.<br>\n" +
						 HTMLPage.getTableHeader (100, 1) +
						 HTMLPage.getTableTopicRow () + 					     
						 "<th>URL</th><th>filename</th><th>content-type</th><th>size</th><th>expires</th></tr>\n");
	    

	    Enumeration e = Proxy.getCache ().getEntries ();
	    long totalsize = 0;
	    while (e.hasMoreElements ()) {	       
		NCacheEntry lister = (NCacheEntry) e.nextElement ();
		HTTPHeader lheader = (HTTPHeader)lister.getKey ();
		HTTPHeader webheader = (HTTPHeader)lister.getDataHook ();
		String filev = lheader.getRequestURI ();
		if (filev.length () > 60)
		    filev = filev.substring (0,57) + "...";
		res.append ("<tr><td><a href = \"" + lheader.getRequestURI () + "\" target = cacheview>" + filev + "</a></td>" + 
			    "<td>" + lister.getFileName () + "</td>" +
			    "<td>" + webheader.getHeader ("Content-Type") + "</td>" +
			    "<td>" + lister.getSize () + "</td>" +
			    "<td>" + lister.getExpires () + "</td></tr>\n");
		totalsize += lister.getSize ();
	    }
	    res.append ("<tr><td><B>Total:</b></td><td>&nbsp;</td><td>&nbsp;</td><td>" + totalsize + "</td><td>&nbsp;</td></tr>\n");
	    res.append ("</table>\n</body></html>");	       
	    
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write cachestatus");
	}
    }
}
