package rabbit.meta;

// $Id: ClearCache.java,v 1.2 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.Properties;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;

/** Clears the cache on all files that are in it.
 */
public class ClearCache implements MetaHandler {
    /** default constructor */
    public ClearCache () {
    }

    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {
	    output.writeHTTPHeader (con.getHeader ());
	    StringBuffer res = new StringBuffer (HTMLPage.getPageHeader ("Removing all files in the cache directory."));
	    res.append ("Please be patient....<br>");
	    output.write (res.toString ().getBytes ());
	    Proxy.getCache ().clear ();
	    output.write (("<font color=\"blue\">done!</font></body></html>\n").getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write cache-cleared message to client");
	} 
	return;    
    }  
}
