package rabbit.meta;

// $Id: Connections.java,v 1.2 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;

/** The Metapage that shows the external connections the proxy 
 *  has keepalive to.
 */
public class Connections implements MetaHandler {

    /** default constructor */
    public Connections () {
    }

    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {      
	    ConnectionHandler ch = Proxy.getConnectionHandler ();
	    output.writeHTTPHeader (con.getHeader ());
	    StringBuffer res = new StringBuffer (HTMLPage.getPageHeader ("Current external connections") +
						 "Cleaner is running?: " + ch.isCleanerRunning () + "<br>\n" +
						 "Keepalive is set to: " + (ch.getKeepaliveTime () / 1000) + " s.<br><br><br>\n" +
						 HTMLPage.getTableHeader (100, 1) +
						 HTMLPage.getTableTopicRow () + 
						 "<th width=\"30%\">InetAddress</th><th width=\"20%\">Port</th>" +
						 "<th width=\"50%\">#Connection</th>\n");
	    
	    Enumeration e = ch.getAddresses ();
	    while (e.hasMoreElements ()) {
		ConnectionHandler.Address a = (ConnectionHandler.Address)e.nextElement ();
		Vector pool = ch.getPool (a);
		res.append ("<tr><td>" + a.ia + 
			    "</td><td>" + a.port + 
			    "</td><td>" + pool.size () + "</td></tr>\n");
	    }
	    res.append ("</table>\n</body></html>\n");
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write status");
	}
    }
}
