package rabbit.meta;

// $Id: MetaHandler.java,v 1.4 2001/12/09 22:00:06 robo Exp $ 

import java.io.*;
import java.net.URL;
import java.util.Properties;

import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.Connection;

/** This interface specifies the methods methapages has to implement
 */
public interface MetaHandler {

    /** Handler of a MetaPage, that is a special page the proxy supports (like the status page).
     *  This method may be called by several threads simultaniously, synchronize when needed.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con);
}
