package rabbit.meta;

// $Id: Status.java,v 1.4 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;

/** the Metapage that shows the status of the proxy.
 */
public class Status implements MetaHandler {
    /** default constructor */
    public Status () {
    }

    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	try {      
	    Vector convec = Proxy.getCurrentConections ();
	    output.writeHTTPHeader (con.getHeader ());
	    StringBuffer res = new StringBuffer (HTMLPage.getPageHeader ("Status") +
						 "Version: " + Proxy.VERSION + "<br>\n" +
						 "Running on: " + Proxy.getHost () + " <B>:</B> " + Proxy.getPort () + "<br>\n" + 
						 "Started at: " + Proxy.getStartDate () + "<br>\n" +
						 "Current time: " + new Date () + "<br>\n" +
						 "Alive and kicking with " + convec.size () + " current " +
						 "connections.<br>\n" +
						 HTMLPage.getTableHeader (100, 1) +
						 HTMLPage.getTableTopicRow () + 
						 "<th width=\"20%\">InetAddress</th><th>Id</th><th width=\"50%\">Connection</th>" +
						 "<th width=\"20%\">Status</th><th>Time(s)</th></tr>\n");
	    long now = new Date ().getTime ();
	    for (int i = 0; i < convec.size (); i++) {
		Connection hth = (Connection)convec.elementAt (i);
		res.append ("<tr><td>" + hth.getSocket ().getInetAddress ().getHostAddress () + 
			    "</td><td><nobr>" + hth.getName () + 
			    "</nobr></td><td>"+ hth.getRequestLine () +
			    "</td><td>" + hth.getStatus () + 
			    "</td><td>" + ((now - hth.getStarted ().getTime())/1000) + "</td></tr>\n");
	    }
	
	    res.append ("</table>\n<br>\n" + HTMLPage.getTableHeader (100, 1) + HTMLPage.getTableTopicRow ());
	    res.append ("<th>thingy</th><th width=\"10%\">times</th></tr>\n");
	
	    // add the logged things.
	    Enumeration e = Proxy.getCounter ().keys ();
	    while (e.hasMoreElements ()) {
		String type = (String) e.nextElement ();
		int val = Proxy.getCounter ().get (type);
		res.append ("\t<tr><td>" + type + "</td><td>" + val + "</td></tr>\n");
	    }
	
	    res.append ("</table>\n</body></html>");
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write status");
	}
    }
}
