package rabbit.meta;

// $Id: UserGetter.java,v 1.2 2001/12/09 22:00:06 robo Exp $

import java.io.*;
import java.net.*;
import java.util.*;

import rabbit.filter.*;
import rabbit.html.*;
import rabbit.http.*;
import rabbit.io.*;
import rabbit.proxy.*;
import rabbit.util.*;

/** A metapage that allows configuration of valid users.
 */
public class UserGetter implements MetaHandler {
    private static final String mark = "users=";

    /** default constructor */
    public UserGetter () {
    }
    
    /** handler of a MetaPage, that is a special page the proxy supports (like the status page).
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param header the http request header
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param con the Connection that is serving the request.
     */
    public void handle (InputStream input, 
			MultiOutputStream output, 
			HTTPHeader header, 
			Properties htab, 
			Connection con) {
	HTTPHeader response = con.getHeader ();
	
	StringBuffer res = new StringBuffer ();

	String content = header.getContent ();
	if (content != null) {
	    int i = content.indexOf (mark);
	    String userstring = null;
	    if (i > -1) {
		int j = content.indexOf ('&', i);
		if (j == -1)
		    j = content.length ();
		if (j > -1) {
		    userstring = content.substring (i + mark.length (),j);
		    userstring = Coder.URLdecode (userstring);
		    try {
			HTTPBaseFilter.loadUsers (new StringReader (userstring));
			HTTPBaseFilter.saveUsers (new StringReader (userstring));
		    } catch (IOException e) {
			// Ignore..
		    }
		}
	    }
	}
	
	res.append (HTMLPage.getPageHeader ("User Configuration"));
	
	res.append ("<form method=post action=UserGetter><TEXTAREA name=users ROWS=10 COLS=55>");

	Hashtable users = HTTPBaseFilter.getUsers ();
	Enumeration usernames = users.keys ();
	while (usernames.hasMoreElements ()) {
	    String username = (String)usernames.nextElement ();
	    String pwd = (String)users.get (username);
	    res.append (username);
	    res.append (':');
	    res.append (pwd);
	    res.append ('\n');
	}
	res.append ("</textarea><br><input type=\"submit\" value=\"Save\"></form>");
	res.append ("</body></html>");

	try {      
	    output.writeHTTPHeader (response);
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write ConfigGetter");
	}	
    }
}
