package rabbit.util;

// $Id: Counter.java,v 1.1.1.1 1999/12/18 18:49:32 robo Exp $

import java.util.*;

/** This class counts different messages
 */
public class Counter 
{
    // All the messages we count.
    private Hashtable counters = new Hashtable ();    
    
    /** This class holds one messages counts
     */
    class Count 
    {
	String message;
	private int counter = 0;
	
	/** Create a new Count
	 */
	Count (String name) {
	    message = name;
	}
	
	/** Increase its value by one
	 */
	void inc () {
	    counter++;
	}
	
	/** Get the count for this message
	 * @return the number of times this message has been counted.
	 */
	public int count () {
	    return counter;
	}
    }

    /** increase a logentry.
     * @param log the event to increase 
     */
    public void inc (String log) {
	Count l = (Count)(counters.get(log));
	if (l == null) {
	    l = new Count (log);
	    counters.put (log,l);
	}
	l.inc ();	
    }
    
    /** get all events
     * @return an Enumeration of all events
     */
    public Enumeration keys () {
	return counters.keys ();
    }

    /** get all values (unsorted)
     * @return an Enumeration of all values
     */
    public Enumeration values () {
	return counters.elements ();
    }

    /** get the current count for an event.
     * @param key the event were intrested in
     * @return the current count of event.
     */
    public int get (String key) {
	Count l = (Count)counters.get (key);
	if (l == null)
	    return 0;
	else 
	    return l.count ();
    }
}

